/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is FirefoxView Mozilla Extension.
 * The Initial Developer of the Original Code is Alex Sirota <alex@elbrus.com>. 
 * Portions created by Alex Sirota are Copyright (C) 2004 Alex Sirota. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function firefoxviewFirefoxViewToBeUninstalled() {
   var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
             .getService(Components.interfaces.nsIRDFService);
   var Container = Components.classes["@mozilla.org/rdf/container;1"]
             .getService(Components.interfaces.nsIRDFContainer);
   var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
	      .getService(Components.interfaces.nsIExtensionManager).datasource;
   var root = RDFService
             .GetResource("urn:mozilla:extension:root");
   var nameArc = RDFService
             .GetResource("http://www.mozilla.org/2004/em-rdf#name");
   var toBeUninstalledArc = RDFService
             .GetResource("http://www.mozilla.org/2004/em-rdf#toBeUninstalled");

   Container.Init(extensionDS,root);

   var found = false;
   var elements = Container.GetElements();
   while (elements.hasMoreElements()) {
	var element = elements.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	var name = "";
	var toBeUninstalled = "";

	var target = extensionDS.GetTarget(element, nameArc ,true);
	if (target) {
		name = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
 	}

        target = extensionDS.GetTarget(element, toBeUninstalledArc ,true);
	if (target) {
        	toBeUninstalled=target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	}
    
	if (toBeUninstalled && (toBeUninstalled == "true") && (name == "FirefoxView")) {
		found = true;
	}
   } 
   return found;
}

function firefoxviewInitOverlay() {
   // the function returns null if there is no preference at all, meaning first time this is run
   if (firefoxviewIsInstalled() == null) {
	firefoxViewInstall();
   }
}

function firefoxviewUnloadOverlay() {
   if (firefoxviewFirefoxViewToBeUninstalled()) {
	// we have been uninstalled, uninstall the menu items
	firefoxViewUnInstall();
	// clear the is_installed flag, so the next time the extension is installed
	// the menu items will be installed automatically
	firefoxviewClearInstalled();
   }
}

addEventListener("load", firefoxviewInitOverlay, false);
addEventListener("unload", firefoxviewUnloadOverlay, false);


